package AnhangB_Http;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

public class HttpURLConnectionMongoDbExample
{
    public static void main(final String[] args) throws Exception
    {
        final String basePath = "http://127.0.0.1:28017/";

        performGet(new URL(basePath + "listDatabases"));
        performGet(new URL(basePath + "mongoexample/persons/"));
        performGet(new URL(basePath + "mongoexample/persons/?filter_vorname=Tim"));
    }

    private static void performGet(final URL url) throws IOException
    {
        final HttpURLConnection con = (HttpURLConnection) url.openConnection();
        con.setRequestMethod("GET");
        con.setRequestProperty("User-Agent", "HttpURLConnectionMongoDbExample");

        System.out.println("\nSending 'GET' request to URL: '" + url + "'");
        System.out.println("Response Code: " + con.getResponseCode());
        System.out.println(extractResponse(con));
    }

    protected static String extractResponse(final HttpURLConnection con) throws IOException
    {
        final StringBuilder response = new StringBuilder();
        try (final BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream())))
        {
            String inputLine;
            while ((inputLine = in.readLine()) != null)
            {
                response.append(inputLine);
            }
        }
        return response.toString();
    }
}
