package ch01.json;

import java.util.Arrays;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
import com.fasterxml.jackson.annotation.PropertyAccessor;
import com.fasterxml.jackson.databind.ObjectMapper;

/**
 * Beispielklasse zur Demonstration der JSON-Verarbeitung mit Jackson
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class JacksonJsonExample
{
    public static void main(final String[] args) throws Exception
    {
        final List<Person> persons = createDemoPersons();

        final ObjectMapper mapper = new ObjectMapper();
        mapper.setVisibility(PropertyAccessor.FIELD, Visibility.ANY);

        final String jsonAsString = mapper.writeValueAsString(persons);
        System.out.println("List -> JSON: " + jsonAsString);

        final List<Person> readInPersons = mapper.readValue(jsonAsString, List.class);
        System.out.println("\nJSON -> List: " + readInPersons);
    }

	private static List<Person> createDemoPersons()
	{
	    final List<String> michasHbbies = Arrays.asList("Java", "Fotografie");
	    final List<String> timsHobbies = Arrays.asList("Hifi", "Java");
	
	    final Person micha = new Person("Michael", "Inden", 44, michasHbbies);
	    final Person tim = new Person("Tim", "Bötz", 44, timsHobbies);
	
	    return Arrays.asList(micha, tim);
	}
}