package ch01.json;

import java.util.Arrays;
import java.util.List;

/**
 * Hilfsklasse zur JSON-Verarbeitung mit Jackson
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class JsonMapperExample
{
    public static void main(final String[] args) throws Exception
    {
        final List<Person> persons = createDemoPersons();

        final String jsonAsString = JsonMapper.toJsonString(persons);
        System.out.println("List -> JSON: " + jsonAsString);

        final List<Person> readInPersons = JsonMapper.fromJsonString(jsonAsString, List.class);
        System.out.println("\nJSON -> List: " + readInPersons);
    }

    private static List<Person> createDemoPersons()
    {
        final List<String> michasHbbies = Arrays.asList("Java", "Fotografie");
        final List<String> timsHobbies = Arrays.asList("Hifi", "Java");

        final Person micha = new Person("Michael", "Inden", 44, michasHbbies);
        final Person tim = new Person("Tim", "Bötz", 44, timsHobbies);

        return Arrays.asList(micha, tim);
    }
}