package ch01.xml.jaxb;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Beispielklasse zur JAXB-Verarbeitung
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
@XmlRootElement(name = "Person2")
// Ändern der Reihenfolge der Elemenete im XML-Dokument
@XmlType(propOrder = { "alter", "name", "vorname" })
@XmlAccessorType(XmlAccessType.FIELD)
public class Person2
{
    private String vorname;

    @XmlElement(name = "lastname")
    private String name;

    @XmlAttribute(name = "age")
    private int    alter;

    // durch JAXB benötigt
    public Person2()
    {
    }

    public Person2(final String vorname, final String name, final int alter)
    {
        this.vorname = vorname;
        this.name = name;
        this.alter = alter;
    }

    //	@XmlAttribute(name="age") 
    public int getAlter()
    {
        return alter;
    }

    //	@XmlElement(name = "lastname")
    public String getName()
    {
        return name;
    }

    public String getVorname()
    {
        return vorname;
    }

    public void setVorname(String surname)
    {
        this.vorname = surname;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public void setAlter(int alter)
    {
        this.alter = alter;
    }

    @Override
    public String toString()
    {
        return "Person [vorname=" + vorname + ", name=" + name + ", alter=" + alter + "]";
    }
}
