package ch01.xml.jaxb.stax;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

/**
 * Beispiel zur Objektrekonstruktion beim Lesen mit DOM 
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class JAXBReadExample
{
    public static void main(final String[] args) throws FileNotFoundException, JAXBException, IOException
    {
        final String input = "resources/ch01/xml/jaxb/stax/Personen.xml";

        final List<Person> persons = readPersonsc(input);
        System.out.println("Extracted persons: " + persons);
    }

    private static List<Person> readPersonsc(final String filename)
                    throws JAXBException, FileNotFoundException, IOException
    {
        final JAXBContext context = JAXBContext.newInstance(Personen.class);
        final Unmarshaller unmarshaller = context.createUnmarshaller();

        try (final InputStream is = new BufferedInputStream(new FileInputStream(filename)))
        {
            final Personen personen = (Personen) unmarshaller.unmarshal(is);
            return personen.getPersons();
        }
    }
}
