package ch01.xml.jaxb.stax;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Beispiel zur Verarbeitung mit XML
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
@XmlRootElement(name = "Person")
@XmlAccessorType(XmlAccessType.FIELD)
public class Person {

	@XmlAttribute
	private String vorname;
	@XmlAttribute
	private String name;
	@XmlAttribute
	private int alter;

	// durch JAXB benötigt
	public Person()
	{	
	}
	
	public Person(final String vorname, final String name, final int alter) {
		this.vorname = vorname;
		this.name = name;
		this.alter = alter;
	}

	public int getAlter() {
		return alter;
	}

	public String getName() {
		return name;
	}

	public String getVorname() {
		return vorname;
	}

	public void setVorname(String surname) {
		this.vorname = surname;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setAlter(int alter) {
		this.alter = alter;
	}

	@Override
	public String toString() {
		return "Person [vorname=" + vorname + ", name=" + name + ", alter="
				+ alter + "]";
	}	
}
