package ch01.xml.jaxp.sax;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

/**
 * Beispiel eines SAX-Handler zur Konsolenausgabe
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class ConsoleOutputContentHandler extends org.xml.sax.helpers.DefaultHandler 
{
    @Override
    public void startElement(final String uri, final String localName, 
                             final String qName, final Attributes atts)
             throws SAXException
    {
        System.out.println("start of element: " + qName);
        printAttributes(atts);
    }

    @Override
    public void endElement(final String uri, final String localName, 
                           final String qName) throws SAXException
    {
        System.out.println("end of element: " + qName);
    }

    protected void printAttributes(final Attributes attributes) 
    {
        for (int i = 0; i < attributes.getLength(); i++)
        {
            System.out.println(attributes.getLocalName(i) + "=" + 
                               attributes.getValue(i));
        }
    }
}