package ch01.xml.jaxp.sax;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 * Beispiel zum Parsen mit SAX
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class FirstSaxExample
{
	public static void main(final String[] args)
	{
	    final File xmlFile = new File("resources/ch01/xml/jaxp/sax/Personen.xml");
	    parseXmlWithSAX(xmlFile, new ConsoleOutputContentHandler());
	}

	public static void parseXmlWithSAX(final File xmlFile, 
	                               final DefaultHandler contentHandler)
	{
		final SAXParserFactory factory = SAXParserFactory.newInstance();

		try
		{
		   final SAXParser parser = factory.newSAXParser();
		   parser.parse(xmlFile, contentHandler);
		}
		catch (final ParserConfigurationException | SAXException | IOException e)
		{
		   System.out.println("Error parsing xml: " + e);
		}
	}
}

