package ch01.xml.jaxp.sax;

import java.io.File;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.web.WebEngine;
import javafx.scene.web.WebView;
import javafx.stage.Stage;

/**
 * Beispiel einer einfachen Aufbereitung von XML als HTML mit SAX
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
@SuppressWarnings("restriction")
public class XmlToHtmlConverterSaxExample extends Application
{
    @Override
    public void start(final Stage primaryStage)
    {
        final File xmlFile = new File("resources/ch01/xml/jaxp/sax/Personen.xml");
        final SimpleXmlToHtmlConverter contentHandler = new SimpleXmlToHtmlConverter();
        FirstSaxExample.parseXmlWithSAX(xmlFile, contentHandler);

        final WebView webView = new WebView();
        final WebEngine webEngine = webView.getEngine();
        final String htmlContent = contentHandler.contentAsHtml();
        webEngine.loadContent(htmlContent);

        primaryStage.setScene(new Scene(webView, 350, 150));
        primaryStage.setTitle(getClass().getSimpleName());
        primaryStage.show();
    }

    public static void main(final String[] args)
    {
        launch(args);
    }
}
