package ch01.xml.jaxp.stax;

import java.io.IOException;

import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;

/**
 * Beispiel zum Schreiben mit StAX
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class StAXCursorBasedWriterExample
{
    public static void main(final String[] args) throws XMLStreamException, IOException
    {
        final XMLOutputFactory outFactory = XMLOutputFactory.newInstance();
        // outFactory.setProperty(OutputKeys.INDENT, "yes");
        final XMLStreamWriter writer = outFactory.createXMLStreamWriter(System.out);

        writer.writeStartDocument();

        // öffnende Elemente schreiben
        writer.writeStartElement("Personen");
        writer.writeStartElement("Person");

        // Attribute schreiben
        writer.writeAttribute("vorname", "Michael");
        writer.writeAttribute("name", "Inden");
        writer.writeAttribute("alter", "44");
        writer.writeEndElement();

        // Spezialzeichen schreiben    
        writer.writeStartElement("Spezialtext");
        writer.writeCharacters("Dies ist ein Text mit Spezialzeichen >> ? <<");
        writer.writeEndElement();

        writer.writeEndElement();
        writer.writeEndDocument();

        writer.close();
    }
}
