package ch01.xml.jaxp.stax;

import java.io.FileNotFoundException;

import javax.xml.stream.XMLEventFactory;
import javax.xml.stream.XMLEventWriter;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.XMLEvent;

/**
 * Beispiel zum Schreiben mit StAX
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class StAXEventWriterExample
{
    public static void main(final String[] args) throws FileNotFoundException, XMLStreamException
    {
        final XMLOutputFactory outputFactory = XMLOutputFactory.newInstance();
        final XMLEventWriter writer = outputFactory.createXMLEventWriter(System.out);

        try
        {
            final XMLEventFactory eventFactory = XMLEventFactory.newInstance();
            final XMLEvent startPerson = eventFactory.createStartElement("", "", "Person");
            final XMLEvent attrVorname = eventFactory.createAttribute("vorname", "Joe");
            final XMLEvent attrName = eventFactory.createAttribute("name", "Black");
            final XMLEvent attrAlter = eventFactory.createAttribute("alter", "51");
            final XMLEvent endPerson = eventFactory.createEndElement("", "", "Person");

            writer.add(eventFactory.createStartDocument());
            writer.add(eventFactory.createStartElement("", "", "Personen"));
            writer.add(startPerson);
            writer.add(attrVorname);
            writer.add(attrName);
            writer.add(attrAlter);
            writer.add(endPerson);
            writer.add(eventFactory.createEndElement("", "", "Personen"));
            writer.add(eventFactory.createEndDocument());
        }
        finally
        {
            writer.close();
        }
    }
}
