/* SQL-Skript                        */
/* Java-Profi: Persistenzlösungen    */
/* (C) 2012-2016 Michael Inden       */
/* --------------------------------  */

/* Schritt 0: Initiale Aufräumarbeiten */
/* ----------------------------------- */

/* Reihen folge wegen Fremdschlüssel-Beziehungen wichtig */
DROP TABLE IF EXISTS Adressen;
DROP TABLE IF EXISTS Mitarbeiter;
DROP TABLE IF EXISTS Personen;
DROP TABLE IF EXISTS Firmen;

/* Schritt 1: Tabelle initial erzeugen */
/* ----------------------------------- */

CREATE TABLE Personen
(
	ID INTEGER PRIMARY KEY,
	Vorname VARCHAR(50) NOT NULL,
	Name VARCHAR(50) NOT NULL,
	Geburtstag DATE
);

CREATE TABLE Adressen
(
	ID INTEGER PRIMARY KEY,
	Strasse VARCHAR(50),
	HausNr VARCHAR(10),
	PLZ INTEGER,
	Stadt VARCHAR(50)
);

CREATE TABLE Firmen
(
	ID INTEGER PRIMARY KEY,
	Name VARCHAR(50),
);

CREATE TABLE Mitarbeiter
(
	ID INTEGER PRIMARY KEY,
	MitarbeiterNr INTEGER,
	Abteilung VARCHAR(50)
);

/* Schritt 2: Änderung der Tabelle Adressen */
/* ---------------------------------------- */
ALTER TABLE Adressen ADD PersonenID INTEGER;

/* Schritt 3: Fremdschlüsselbeziehungen erstellen */
/* ---------------------------------------------- */
ALTER TABLE Adressen ADD FOREIGN KEY (PersonenID) REFERENCES Personen (ID);

/* Schritt 4: Index für Tabelle Personen erstellen */
/* ----------------------------------------------- */
CREATE INDEX IDX_PersonenName ON Personen (Name); 