package ch03.jdbc.orm;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;

/**
 * Beispielklasse zur Modellierung einer Person
 * 
 * @author Michael Inden
 * 
 * Copyright 2012, 2016 by Michael Inden 
 */
public final class Person
{
    private final String firstname;
    private final String lastname;
    private final Date dateOfBirth;
    private final List<Address> addresses = new ArrayList<>();

    public Person(final String firstname, final String lastname, final Date dateOfBirth)
    {
        this.firstname = firstname;
        this.lastname = lastname;
        this.dateOfBirth = dateOfBirth;
    }

    public void setAddresses(final List<Address> addresses)
    {        
        this.addresses.clear();
        this.addresses.addAll(addresses);
    }

    public List<Address> getAddresses()
    {
        return Collections.unmodifiableList(addresses);
    }

    @Override
    public String toString()
    {
        return "Person [firstname=" + firstname + ", lastname=" + lastname + ", dateOfBirth=" + dateOfBirth + ", addresses="
                        + addresses + "]";
    }
}   
 