package ch05.mongo;

import java.util.Arrays;
import java.util.List;

/**
 * Beispielklasse zur Bereitstellung von Testdaten
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class ExampleData {
	public static final List<String> names = Arrays.asList("Micha", "Tim",
			"Andy", "Lili", "Barbara", "Clemens", "Merten", "Marius");
	public static final List<String> hobbies = Arrays.asList("Sport",
			"Reisen", "Musik", "TV", "Kino", "Wandern", "Fotografieren");

	static class Address {
		public final String state;
		public final int zipCode;
		public final String city;
		public final State stateEnum;
		
		public Address(final String state, final int zipCode, final String city) {
			this.state = state;
			this.zipCode = zipCode;
			this.city = city;
			this.stateEnum = State.CH;
		}		

        public Address(final String state, final int zipCode, final String city, final State stateEnum) {
            this.state = state;
            this.zipCode = zipCode;
            this.city = city;
            this.stateEnum = stateEnum;
        }
	}
	
	public static final List<Address> addresses = Arrays.asList(
		new Address("CH", 8952, "Schlieren", State.CH), new Address("DE", 24106, "Kiel", State.DE),
		new Address("CH", 8003, "Zürich"), new Address("DE", 52070, "Aachen"),
		new Address("A", 1133, "Wien"));
}
