package ch05.mongo;

import java.io.IOException;

import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
import com.fasterxml.jackson.annotation.PropertyAccessor;
import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

/**
 * Hilfsklasse zum Mapping von JSON-Daten
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class JsonMapper 
{
	private static final ObjectMapper mapper = new ObjectMapper();
	static
	{
		mapper.setVisibility(PropertyAccessor.FIELD, Visibility.ANY);	
		mapper.disable(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES);
	}
	
	public static String toJsonString(final Object obj) throws JsonProcessingException
	{
		return mapper.writeValueAsString(obj);
	}

	public static <T> T fromJsonString(final String jsonAsString, final Class<T> type) throws JsonParseException, JsonMappingException, IOException
	{
		return mapper.readValue(jsonAsString, type);
	}                  
}
