package ch05.mongo;

import java.util.ArrayList;
import java.util.List;

import com.mongodb.MongoClient;
import com.mongodb.client.MongoDatabase;
import com.mongodb.client.MongoIterable;

/**
 * Beispielklasse zum Ansprechen von MongoDB mit dem neuen Treiber
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class MongoExampleNewDriver
{
    public static void main(final String[] args)
    {
        try (final MongoClient mongo = new MongoClient("localhost", 27017))
        {
            final MongoIterable<String> itDbNames = mongo.listDatabaseNames();
            final List<String> dbNames = itDbNames.into(new ArrayList<>());
            System.out.println("Database Names: " + dbNames);

            final MongoDatabase db = mongo.getDatabase("mongoexample");
            final MongoIterable<String> itColNames = db.listCollectionNames();
            final List<String> collections = itColNames.into(new ArrayList<>());
            System.out.println("Collections in db 'mongoexample': " + collections);
        }
    }
}