package ch05.mongo;

import java.util.List;
import java.util.Set;

import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
import com.mongodb.MongoClient;

/**
 * Beispielklasse zum Ansprechen von MongoDB mit dem alten Treiber
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class MongoExampleOldDriver2
{
    public static void main(final String[] args)
    {
        try (final MongoClient mongo = new MongoClient("localhost", 27017))
        {
            // deprecated
            final List<String> dbNames = mongo.getDatabaseNames();
            System.out.println("Database Names: " + dbNames);

            // deprecated
            final DB db = mongo.getDB("mongoexample");
            final Set<String> collections = db.getCollectionNames();
            System.out.println("Collections in db 'mongoexample': " + collections);

            DBCollection createCollection = db.createCollection("test", null);
            insertMichael(createCollection);

            queryAll(createCollection);
        }
    }

    private static void insertMichael(final DBCollection collection)
    {
        final DBObject personDbObject = new BasicDBObject("name", "Michael").append("age", "44")
                        .append("bornIn", "Bremen").append("livesIn", "Zürich");
        collection.insert(personDbObject);

        final DBObject personDbObject2 = new BasicDBObject("name", "Anne").append("age", "39")
                        .append("bornIn", "Ahrensburg").append("livesIn", "Dortmund");
        collection.insert(personDbObject2);
    }

    private static void queryAll(final DBCollection collection)
    {
        final DBCursor dbCursor = collection.find();
        dbCursor.forEach(System.out::println);
        dbCursor.close();
    }
}