package ch05.mongo;

import java.util.function.Consumer;

import org.bson.Document;

import com.mongodb.MongoClient;
import com.mongodb.client.FindIterable;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;

/**
 * Beispielklasse zum Einfügen und Lesen von Daten mit MongoDB  
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class MongoInsertAndReadExample
{
    public static void main(final String[] args)
    {
        try (final MongoClient client = new MongoClient("localhost", 27017))
        {
            final MongoDatabase database = client.getDatabase("mongoexample");
            final MongoCollection<Document> collection = database.getCollection("personsinsert");

            insertMichael(collection);
            queryAll(collection);
        }
    }

    protected static void insertMichael(final MongoCollection<Document> collection)
    {
        final Document personDocument = new Document("name", "Michael").append("age", "44").append("bornIn", "Bremen")
                        .append("livesIn", "Zürich");
        collection.insertOne(personDocument);
    }

    protected static void queryAll(final MongoCollection<Document> collection)
    {
        final FindIterable<Document> results = collection.find();
        printAll(results);
    }

    protected static void printAll(final FindIterable<Document> elements)
    {
        final Consumer<Document> consumer = System.out::println;
        elements.forEach(consumer);
    }
}