package ch05.mongo.orm.spring;

import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;

/**
 * Beispielklasse zur Modellierung einer Person mit Spring Data MongoDB
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
@Document(collection = "persons")
public class Person
{
    @Id
    private String id;

    private String firstname;
    private String lastname;
    private int age;
    
    public Person() {}

    public Person(final String firstname, final String lastname, final int age) 
    {
        this.firstname = firstname;
        this.lastname = lastname;
        this.age = age;
    }

    public void changeFirstname(final String newFirstName)
    {
    	this.firstname = newFirstName;
    }

	@Override
	public String toString() 
	{
		return "Person [firstname='" + firstname + "', lastname='" + lastname + "', age=" + age + "]";
	}
}