package ch05.mongo.orm.spring;

import java.util.List;

import org.springframework.data.mongodb.repository.MongoRepository;

/**
 * Beispiel zur Beschreibung eines Repository für Personen mit Spring Data MongoDB
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public interface PersonRepository extends MongoRepository<Person, String> 
{
    public List<Person> findByFirstname(final String firstname);
    public List<Person> findByLastname(final String lastname);
    public List<Person> findByAge(final int age);

    public List<Person> findByAgeGreaterThan(final int age);
    public List<Person> findByAgeBetween(final int from, final int to);
    
    // Besonderheit 1: Es wird der erste Treffer geliefert
    // Besonderheit 2: Die Suche basiert auf zwei Attributen
    public Person findByFirstnameAndLastname(final String firstname, 
    		                                 final String lastname);
}