package ch05.mongo.orm.spring.step2;

import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;

import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;

/**
 * Beispielklasse zur Modellierung einer Person mit Spring Data MongoDB
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
@Document(collection = "personsWithAddresses")
public class Person
{
    @Id
    private String id;
    private String firstname;
    private String lastname;
    private LocalDate birthday;
    
    private List<Address> addresses;
    
    public Person() {}

    public Person(final String firstname, final String lastname, 
    		      final LocalDate birthday, final Address... addresses) 
    {
        this.firstname = firstname;
        this.lastname = lastname;
        this.birthday = birthday;
        this.addresses = Arrays.asList(addresses);
    }

    public void changeFirstName(final String newFirstName)
    {
    	this.firstname = newFirstName;
    }

	@Override
	public String toString() {
		return "Person [firstname=" + firstname + ", lastname=" + lastname
				+ ", birthday=" + birthday + ", addresses=" + addresses + "]";
	}
}