package ch05.mongo.orm.spring.step2;

import java.time.LocalDate;
import java.util.List;

import org.springframework.data.mongodb.repository.MongoRepository;
           
/**
 * Beispiel zur Beschreibung eines Repository für Personen inkl. Adressen mit Spring Data MongoDB
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public interface PersonAddressRepository extends MongoRepository<Person, String> 
{
    public List<Person> findByFirstname(final String firstname);
    public List<Person> findByLastname(final String lastname);
    public List<Person> findByBirthday(final LocalDate birthday);
    
    public List<Person> findByBirthdayGreaterThan(final LocalDate birthday);
    public List<Person> findByBirthdayBetween(final LocalDate from, final LocalDate to);
    
    // Erweiterung für eingebettete Listen von Adressen
    public List<Person> findByAddresses(final Address address);
    public List<Person> findByAddressesCity(final String city);
    public List<Person> findByAddressesZipCode(final int zipCode);
    
    public List<Person> findByAddressesZipCodeOrderByFirstname(final int zipCode);
}