package ch06.rest.jersey.server.advanced;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import org.glassfish.jersey.jdkhttp.JdkHttpServerFactory;
import org.glassfish.jersey.server.ResourceConfig;

import com.sun.net.httpserver.HttpServer;

/**
 * Beispielklasse eines komplexeren REST-Servers
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class AdvancedStandAloneRESTServer 
{
    private static final String BASE_URI = "http://localhost:8888/rest/";
    private static final String PACKAGES = "ch06.rest.jersey.server.advanced";
  
    public static void main(String[] args) throws URISyntaxException, IOException
    {
        final ResourceConfig rc = new ResourceConfig().packages(PACKAGES);
		final HttpServer server = JdkHttpServerFactory.
				                  createHttpServer(URI.create(BASE_URI), rc);

        System.out.println("Advanced REST-Server is running at " + BASE_URI);
        System.in.read();
        server.stop(0);
    }
}
