package ch06.rest.jersey.server.advanced;

import java.io.IOException;
import java.lang.reflect.Method;
import java.util.logging.Logger;

import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerResponseContext;
import javax.ws.rs.container.ContainerResponseFilter;
import javax.ws.rs.container.ResourceInfo;
import javax.ws.rs.core.Context;
import javax.ws.rs.ext.Provider;

@Provider
public class AfterDispatchRestServiceFilter implements ContainerResponseFilter
{
    private static final Logger LOGGER = Logger.getLogger("AfterDispatchRestServiceFilter");

    @Context
    ResourceInfo                resourceInfo;

    @Override
    public void filter(final ContainerRequestContext requestContext, final ContainerResponseContext responseContext)
                    throws IOException
    {
        final Class<?> resourceClass = resourceInfo.getResourceClass();
        final Method method = resourceInfo.getResourceMethod();

        LOGGER.info("called: method '" + method.getName() + "' of class " + resourceClass.getSimpleName());

        if (method.isAnnotationPresent(ShowMethodDetails.class))
        {
            LOGGER.info("=> method details: " + method);
        }
    }
}
