package ch06.rest.jersey.server.advanced;

import java.time.LocalDateTime;

import javax.xml.bind.annotation.adapters.XmlAdapter;

/**
 * Hilfsklasse zur Unterstützung der neuen Datentypen auf dem Date And Time API für XML (bei JAX-RS auch für JSON)
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class LocalDateTimeAdapter extends XmlAdapter<String, LocalDateTime>
{
    @Override
    public LocalDateTime unmarshal(String s) throws Exception
    {
        return LocalDateTime.parse(s);
    }

    @Override
    public String marshal(LocalDateTime dateTime) throws Exception
    {
        return dateTime.toString();
    }
}