package ch06.rest.jersey.server.basics;

import java.time.LocalDateTime;
import java.util.concurrent.atomic.AtomicLong;

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

/**
 * Beispielklasse zur Modellierung von Daten für den REST-Server
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
@XmlRootElement
public class Message
{
    private static AtomicLong counter = new AtomicLong();
    
    private long   id;
    private String msg;
    private LocalDateTime creationDate;
    
    Message()
    {}
    
    public Message(final String msg)
    {
        this.id = counter.getAndIncrement();
        this.msg = msg;
        this.creationDate = LocalDateTime.now();
    }

    public long getId()
    {
        return id;
    }

    public void setId(long id)
    {
        this.id = id;
    }

    public String getMsg()
    {
        return msg;
    }

    public void setMsg(String msg)
    {
        this.msg = msg;
    }

    @XmlJavaTypeAdapter(LocalDateTimeAdapter.class)
    public LocalDateTime getCreationDate()
    {
        return creationDate;
    }

    public void setCreationDate(LocalDateTime creationDate)
    {
        this.creationDate = creationDate;
    }
}