package ch06.rest.jersey.server.basics;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import org.glassfish.jersey.jdkhttp.JdkHttpServerFactory;
import org.glassfish.jersey.server.ResourceConfig;

import com.sun.net.httpserver.HttpServer;

/**
 * Beispielklasse eines einfachen REST-Servers
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class StandAloneRESTServer 
{
    private static final String BASE_URI = "http://localhost:7777/rest/";
    private static final String BASE_PACKAGE = "ch06.rest.jersey.server.basics";
 
    public static void main(final String[] args) throws URISyntaxException, IOException
    {
        final ResourceConfig rc = new ResourceConfig().packages(BASE_PACKAGE);
		final HttpServer server = JdkHttpServerFactory.
				                  createHttpServer(URI.create(BASE_URI), rc);

        System.out.println("Basic-REST-Server is running at " + BASE_URI);
        System.in.read();
        server.stop(0);
    }
}
