package ch07.exampleapp.highscores.iteration1;

import java.time.LocalDate;
import java.util.List;

/**
 * Beispiel zur Verwaltung von Highscores-Daten mit einem HighscoreManager
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class HighscoreListImprovedExample
{
    public static final void main(final String[] args)
    {      
    	final HighscoreManager manager = new HighscoreManager();
    	
    	manager.populateFromCsv("resources/Highscores.csv");
    	manager.add(new Highscore("Michael", 7271, 10, LocalDate.of(2016, 2, 7)));
    	manager.add(new Highscore("Werner", 1000,  8, LocalDate.of(2016, 1, 31)));
    	
    	final List<Highscore> highscores = manager.getHighscores();        
    	highscores.forEach(System.out::println);
    }
}

