package ch07.exampleapp.highscores.iteration1;

import java.util.ArrayList;
import java.util.List;

/**
 * Beispielklasse zur Demonstration der Verwaltung von Highscores-Daten
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class HighscoreManagerV1 
{
	final List<Highscore> highscores = new ArrayList<>();
	
	public List<Highscore> getHighscores()
	{
		// keine internen Daten herausgeben
		return new ArrayList<>(highscores);
	}
		
	public void add(final Highscore highscore)
	{
		highscores.add(highscore);
	}
		
	public void populateFromCsv(final String filePath)
    {      
        final List<Highscore> readHighscores = HighscoresFromCsvImporter.readHighscoresFromCsv(filePath);
        
        highscores.clear();
        highscores.addAll(readHighscores);
    }
}