package ch07.exampleapp.highscores.iteration1;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.util.Collections;
import java.util.List;

/**
 * Beispielklasse zur Persistierung von Highscores-Daten 
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class HighscorePersister 
{
	public void persist(final OutputStream os, 
			            final List<Highscore> highscores) throws IOException 
	{
		final ObjectOutputStream outStream = new ObjectOutputStream(os); 
		outStream.writeObject(highscores);
	}

	public List<Highscore> readFrom(final InputStream is) throws IOException 
	{
		final ObjectInputStream inStream = new ObjectInputStream(is);
		try
		{
			return (List<Highscore>) inStream.readObject();
		}  
		catch (ClassNotFoundException e) 
		{
			// kann hier nicht auftreten, weil alle Klassen unter unserer Kontrolle
		}
		return Collections.emptyList();
	}
}