package ch07.exampleapp.highscores.iteration3;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;

/**
 * Beispielklasse zur Persistierung von Highscores-Daten 
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class HighscorePersister 
{	
	public void persist(final PersistMode mode,
						final OutputStream os, 
			            final List<Highscore> highscores)
	                    throws IOException 
	{
		final IPersistStrategy strategy = mode.getStrategy();
		strategy.persist(os, highscores);
	}

	public List<Highscore> readFrom(final PersistMode mode, 
			                        final InputStream is) 
			                        throws IOException
	{
		final IPersistStrategy strategy = mode.getStrategy();
		return strategy.readFrom(is);
	}
}