package ch07.exampleapp.highscores.iteration3;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import org.glassfish.jersey.jdkhttp.JdkHttpServerFactory;
import org.glassfish.jersey.server.ResourceConfig;

import com.sun.net.httpserver.HttpServer;

/**
 * Diese Klasse stellt einen REST-Server bereit
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden
 */
public class HighscoreRESTServer 
{
    private static final String BASE_URI = "http://localhost:3333/rest/";
    private static final String PACKAGES = "ch07.exampleapp.highscores.iteration3";
    
    public static void main(final String[] args) throws URISyntaxException, IOException
    {
        final HighscoreManager highscoreManager = ManagerProvider.getHighscoreManager();
        highscoreManager.populateFromCsv("resources/Highscores.csv");
        
        final ResourceConfig rc = new ResourceConfig().packages(PACKAGES);
		final HttpServer server = JdkHttpServerFactory.
				                  createHttpServer(URI.create(BASE_URI), rc);		

        System.out.println("Highscore-REST-Server is running at " + BASE_URI);
        System.in.read();
        server.stop(0);
    }
}
