function addTable() {

    var highscores = getHighscoresFromREST();
    var table = createHtmlTable(highscores);

    var myDynTable = document.getElementById("myDynTableDiv");
    myDynTable.innerHTML = "";
    myDynTable.appendChild(table);
}

function getHighscoresFromREST() 
{
    var highscores = new Array();

    var xhr = new XMLHttpRequest();    
    xhr.open("get", "http://localhost:3333/rest/highscores", false);
    xhr.setRequestHeader("Accept", "application/xml");
    xhr.onreadystatechange = function () 
    {
        if (xhr.readyState == 4 && xhr.status == 200) 
        {

          extractHighscoresFromXml(xhr, highscores);
        }
    };
    xhr.send();

    return highscores;
}

function extractHighscoresFromXml(xhr, highscores) 
{
    var xmlDoc = xhr.responseXML;
    var allhighscoreNodes = xmlDoc.getElementsByTagName("highscore");
    for (i = 0; i < allhighscoreNodes.length; i++) 
    {
        var highscoreNode = allhighscoreNodes[i];

        var name = getChildNodeValue(highscoreNode, "name");
        var points = getChildNodeValue(highscoreNode, "points");
        var level = getChildNodeValue(highscoreNode, "level");
        var day = getChildNodeValue(highscoreNode, "day");
        var id = getChildNodeValue(highscoreNode, "id");
        
        highscores.push([name, points, level, day, id]);
    }  
}

function getChildNodeValue(element, name) 
{
    return getChildElement(element, name).childNodes[0].nodeValue;
}

function getChildElement(element, name) 
{
    var child = element.firstChild;
    while (child) 
    {
        if (child.nodeType == Node.ELEMENT_NODE && child.nodeName == name) 
        {
            return child;
        }
        child = child.nextSibling;
    }
}

function createHtmlTable(highscores) 
{
    var table = document.createElement("TABLE");
    table.id = "myTable"
    table.border = "1";

    // Add the header row.
    var headerColumns = ["", "Name", "Points", "Level", "Date", "id"];
    var headerColumnsCount = headerColumns.length;
    var row = table.insertRow(-1);
    for (var i = 0; i < headerColumnsCount; i++) 
    {
        var headerCell = document.createElement("TH");
        headerCell.innerHTML = headerColumns[i];
        row.appendChild(headerCell);
    }

    // Add the data rows.
    var columnCount = highscores[0].length;
    for (var i = 0; i < highscores.length; i++) 
    {
        row = table.insertRow(-1);

        var cell = row.insertCell(-1);
        var id = highscores[i][4];
        cell.innerHTML = "<input type='button' value = 'Delete' " + 
                         "onClick='Javacsript:deleteRow(this,"+id+")'>";

        for (var j = 0; j < columnCount; j++) 
        {
            var cell = row.insertCell(-1);
            cell.innerHTML = highscores[i][j];
        }
    }

    return table;
}

function deleteRow(obj, id) 
{
    var index = obj.parentNode.parentNode.rowIndex;
    var table = document.getElementById("myTable");
    table.deleteRow(index);

    // delete & reload from server
    deleteHighscoreWithREST(id);
    addTable();
}

function deleteHighscoreWithREST(id) 
{
    var xhr = new XMLHttpRequest();    
    xhr.open("delete", "http://localhost:3333/rest/highscores/" + id, false);
    xhr.send();
}

function createHighscoreWithREST() 
{
    var form = document.getElementById("createForm");
    var queryString = joinFormParameters(form);

    var xhr = new XMLHttpRequest();    
    xhr.open("post", "http://localhost:3333/rest/highscores/", false);
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded"); 
    xhr.setRequestHeader("Content-length", queryString.length);
    xhr.send(queryString);

    addTable();
}

function joinFormParameters(form) 
{    
    var keyvaluepairs = [];

    for (var i = 0; i < form.elements.length; i++ ) 
    {
        var e = form.elements[i];
        keyvaluepairs.push(encodeURIComponent(e.name) + "=" + encodeURIComponent(e.value));
    }
    
    return keyvaluepairs.join("&");
}