package ch04.jpa.orm.validation;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * Beispielklasse zur Modellierung eines Kunden mit JPA-Annotations 
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
@Entity
@NamedQueries( { @NamedQuery(name = "findAllCustomers", 
                             query = "SELECT c FROM Customer c") })
public class Customer 
{
    @Id
    @GeneratedValue
    private Long id;

    @NotNull
    @Size(min = 5, max = 20)
    private String name;

    public Customer() 
    {
    }

    public Customer(final String name) 
    {
        this.name = name;
    }
    
    public Long getId() 
    {
		return id;
	}

	public void setId(Long id) 
	{
		this.id = id;
	}

	public String getName() 
	{
		return name;
	}

	public void setName(String name) 
	{
		this.name = name;
	}
}