package ch06.rest.jersey.advanced.restfuse;

import static com.eclipsesource.restfuse.Assert.assertOk;
import static org.junit.Assert.assertEquals;

import org.junit.Rule;
import org.junit.runner.RunWith;

import com.eclipsesource.restfuse.Destination;
import com.eclipsesource.restfuse.HttpJUnitRunner;
import com.eclipsesource.restfuse.MediaType;
import com.eclipsesource.restfuse.Method;
import com.eclipsesource.restfuse.Response;
import com.eclipsesource.restfuse.annotation.Context;
import com.eclipsesource.restfuse.annotation.HttpTest;

// Spezieller Testrunner
@RunWith(HttpJUnitRunner.class) 
public class BeispielRestfuseTest 
{
	// Definition der Basis-URL
	@Rule
	public final Destination destination = new Destination(this, "http://localhost:7777/rest/");

	@Context
	private Response response; // wird nach jedem Request injiziert

	// Verweist auf die auszuführende REST-Methode
	@HttpTest(method = Method.GET, path = "/greeting/Micha") 
	public void sayHelloPlainText() 
	{	
		final String body = response.getBody();
		final int responseCode = response.getStatus();		
		
		// Spezielles Assert von restfuse, die auf den HTTP Code 200 prüft
		assertOk( response );
		
		assertEquals( 200, responseCode);
		assertEquals("Hello Micha", body);
		assertEquals(MediaType.TEXT_PLAIN, response.getType());
	}
}